#ifndef _UTILS_HPP
#define _UTILS_HPP

double drand();

double rand(double s, double e);

template <typename T> int sgn(T val) {
    return (T(0) < val) - (val < T(0));
}

#define NEAR_ZERO_THRESHOLD 0.000001

template <typename T> int nearZero(T val) {
    return val < NEAR_ZERO_THRESHOLD && val > -NEAR_ZERO_THRESHOLD;
}

#endif