#ifndef _ITERATION_HPP
#define _ITERATION_HPP

#include <SFML/Graphics.hpp>
#include <vector>
#include "Vector.hpp"

struct Particle {
    Vector pos;
    Vector vel;
    int client;
};

class Iteration {
public:
    Iteration(int index = 0);

    void load();

    void generateVertexArray();

    void draw(sf::RenderTarget& target);

    int getParticleCount() const;

private:
    std::vector<Particle*> m_particles;
    sf::VertexArray m_vertexArray;
    int m_index;
    double mesh_x, mesh_y;
};

#endif